function [xp, yp, sp, success]=pd_project(x,y,s,B,N,A,b,c)
%version: rmpc v3.0
%attempts to project advanced iterate onto optimal face
%
%inputs:
% x,y,s: current iterate
% B/N are the estimated strict complementary index partition
% A,b,c are the problem data
%outputs:
% xp,yp,sp: projected iterate
% success: 1 for success, 0 for fail

%zero tolerance (things less than this are considered close enough to zero)
tol=1e-10;

[m,n]=size(A);

AB=A(:,B);
AN=A(:,N);

%minimum norm solution to Bdx=b-Bx gives primal correction
%minimum norm solution to B'dy=s(B) gives dual correction
%matlab backslash does the right thing
dx=AB\(b-AB*x(B));
dy=AB'\s(B);

xp=zeros(n,1);
sp=zeros(n,1);

xp(B)=x(B)+dx;
yp=y+dy;
sp(N)=c(N)-AN'*yp;

%these should automatically be satisfied, but check anyways...
np=norm(A*x-b);
nd=norm(A'*y+s-c);

if(min(sp)>=0 && min(xp)>=0 && np<tol && nd<tol) 
    success=1;
else
    success=0;
end

return;
    
